void WriteMemory(_int32 vaddr, int value, HWND hWnd)
{
	
	_int32 oldvaddr=vaddr;
	int mem;
	if((vaddr>=0x80000000) & (vaddr<=0x9FFFFFFF)) vaddr=vaddr-0x80000000;
	if((vaddr>=0xA0000000) & (vaddr<=0xBFFFFFFF)) vaddr=vaddr-0xA0000000;
	if((vaddr>=0) & (vaddr<=0x003FFFFF)) mem=1;
	if((vaddr>=0x03F00000) & (vaddr<=0x03F00027)) mem=2;
	if((vaddr>=0x04000000) & (vaddr<=0x04000FFF)) mem=12;
	if((vaddr>=0x04001000) & (vaddr<=0x04001FFF)) mem=13;
	if((vaddr>=0x04040000) & (vaddr<=0x0404001F)) mem=14;
	if((vaddr>=0x04080000) & (vaddr<=0x04080007)) mem=22;
	if((vaddr>=0x04100000) & (vaddr<=0x0410001F)) mem=24;
	if((vaddr>=0x04200000) & (vaddr<=0x0420000F)) mem=32;
	if((vaddr>=0x04300000) & (vaddr<=0x04300037)) mem=36;
	if((vaddr>=0x04400000) & (vaddr<=0x04400037)) mem=40;
	if((vaddr>=0x04500000) & (vaddr<=0x04500017)) mem=54;
	if((vaddr>=0x04600000) & (vaddr<=0x04600033)) mem=60;
	if((vaddr>=0x04700000) & (vaddr<=0x0470001F)) mem=73;
	if((vaddr>=0x04800000) & (vaddr<=0x0480001B)) mem=81;
	// if((vaddr>=0x05000000) & (vaddr<=0x05FFFFFF)) mem=85;
	// if((vaddr>=0x06000000) & (vaddr<=0x07FFFFFF)) mem=86;
	// if((vaddr>=0x08000000) & (vaddr<=0x0FFFFFFF)) mem=87;
	if((vaddr>=0x10000000) & (vaddr<=0x1FBFFFFF)) mem=88;
switch (mem)
 {
 case 1:
 	 RAM[vaddr]=value;
	 break;
 case 2:
	 RDRAMreg[vaddr-0x03F00000]=value;
	 break;
  case 12:
	 SP_DMEM[vaddr-0x04000000]=value;
	 break;
 case 13:
	 SP_IMEM[vaddr-0x04001000]=value;
	 break;
 case 14:
	 SP_MEMreg[vaddr-0x04040000]=value;
	 break;
 case 22:
	 SP_MEMreg[vaddr-0x04080000]=value;
	 break;
 case 24:
	 DPreg[vaddr-0x04100000]=value;
	 break;
 
 case 32:
	 DPSreg[vaddr-0x04200000]=value;
	 break;
 
 case 36:
	 MIreg[vaddr-0x04300000]=value;
	 break;
 
 case 40:
	 VIreg[vaddr-0x04400000]=value;
	 break;
 
 case 54:
	 AIreg[vaddr-0x04500000]=value;
	 break;
 
 case 60:
	 PIreg[vaddr-0x04600000]=value;
	 break;
 
 case 73:
	 RIreg[vaddr-0x04700000]=value;
	 break;
 
 case 81:
	 SIreg[vaddr-0x04800000]=value;
	 break;
  case 85:
	 SetFilePointer(RomHandle,vaddr-0x05000000,0,FILE_BEGIN);
	 // inf.write(value, 4);
	 break;
 case 86:
	 SetFilePointer(RomHandle,vaddr-0x06000000,0,FILE_BEGIN);
	 // inf.write(value, 4);
	 break;
 case 87:
	 SetFilePointer(RomHandle,vaddr-0x08000000,0,FILE_BEGIN);
	 // value >> inf;
	 break;
 case 88:
	 
	 SetFilePointer(RomHandle,vaddr-0x10000000,0,FILE_BEGIN);
	 // value >> inf;
	 break;
default:
	 sprintf(text,"Unhandled memory address: %x",(vaddr));
	 MessageBox(hWnd,text, "Memory Error",MB_OK);
	 break;
 }
 vaddr=oldvaddr;
}

_int8 ReadMemory(unsigned _int32 vaddr, HWND hWnd)
{
	_int8 something;
	unsigned _int32 oldvaddr=vaddr;
	int mem;
	if((vaddr>=0x80000000) & (vaddr<=0x9FFFFFFF)) vaddr=vaddr-0x80000000;
	if((vaddr>=0xA0000000) & (vaddr<=0xBFFFFFFF)) vaddr=vaddr-0xA0000000;
	if((vaddr>=0) & (vaddr<=0x003FFFFF)) mem=1;
	if((vaddr>=0x03F00000) & (vaddr<=0x03F00027)) mem=2;
	
	if((vaddr>=0x04000000) & (vaddr<=0x04000FFF)) mem=12;
	if((vaddr>=0x04001000) & (vaddr<=0x04001FFF)) mem=13;
	if((vaddr>=0x04040000) & (vaddr<=0x0404001F)) mem=14;
	
	if((vaddr>=0x04080000) & (vaddr<=0x04080007)) mem=22;
	if((vaddr>=0x04100000) & (vaddr<=0x0410001F)) mem=24;
	
	if((vaddr>=0x04200000) & (vaddr<=0x0420000F)) mem=32;
	
	if((vaddr>=0x04300000) & (vaddr<=0x04300037)) mem=36;
	
	if((vaddr>=0x04400000) & (vaddr<=0x04400037)) mem=40;
	
	if((vaddr>=0x04500000) & (vaddr<=0x04500017)) mem=54;
	
	if((vaddr>=0x04600000) & (vaddr<=0x04600033)) mem=60;
	
	if((vaddr>=0x04700000) & (vaddr<=0x0470001F)) mem=73;
	
	if((vaddr>=0x04800000) & (vaddr<=0x0480001B)) mem=81;
	
	// if((vaddr>=0x05000000) & (vaddr<=0x05FFFFFF)) mem=85;
	// if((vaddr>=0x06000000) & (vaddr<=0x07FFFFFF)) mem=86;
	// if((vaddr>=0x08000000) & (vaddr<=0x0FFFFFFF)) mem=87;
	if((vaddr>=0x10000000) & (vaddr<=0x1FBFFFFF)) mem=88;
	switch (mem)
 {
 case 1:
 	 return (_int8)RAM[vaddr];
	 break;
 case 2:
	 return (_int8)RDRAMreg[vaddr-0x03F00000];
	 break;
 
 case 12:
	 return (_int8)SP_DMEM[vaddr-PC];
	 break;
 case 13:
	 return (_int8)SP_IMEM[vaddr-0x04001000];
	 break;
 case 14:
	 return (_int8)SP_MEMreg[vaddr-0x04040000];
	 break;
 case 22:
	 return (_int8)SP_MEMreg[vaddr-0x04080000];
	 break;
 case 24:
	 return (_int8)DPreg[vaddr-0x04100000];
	 break;
  case 32:
	 return (_int8)DPSreg[vaddr-0x04200000];
	 break;
 case 36:
	 return (_int8)MIreg[vaddr-0x04300000];
	 break;
 case 40:
	 return (_int8)VIreg[vaddr-0x04400000];
	 break;
 case 54:
	 return (_int8)AIreg[vaddr-0x04500000];
	 break;
 case 60:
	 return (_int8)PIreg[vaddr-0x04600000];
	 break;
  case 73:
	 return (_int8)RIreg[vaddr-0x04700000];
	 break;
 case 81:
	 return (_int8)SIreg[vaddr-0x04800000];
	 break;
 /*
 case 85:
	 inf.seekg(vaddr-0x05000000);
	 inf.read(u, 4);
	 opcode=(u[0] << 24) + (u[1] << 16) + (u[2] << 8) + u[3];
	 return (_int32)opcode;
	 break;
 case 86:
	 inf.seekg(vaddr-0x06000000);
	 inf.read(u, 4);
	 opcode= (u[0] << 24) + (u[1] << 16) + (u[2] << 8) + u[3];
	 return (_int32)opcode;
	 break;
 case 87:
	 inf.seekg(vaddr-0x08000000);
	 inf.read(u, 4);
	 opcode= (u[0] << 24) + (u[1] << 16) + (u[2] << 8) + u[3];
	 return (_int32)opcode;
	 break;
 case 88:
	 inf.seekg(vaddr-0x10000000);
	 inf.read(u, 4);
	 opcode= (u[0] << 24) + (u[1] << 16) + (u[2] << 8) + u[3];
	 return (_int32)opcode;
	 break;
 */
 case 89:
	 if(vaddr<=(OldPC+64))
	 {
		 SetFilePointer(RomHandle,vaddr-OldPC+64,0,FILE_BEGIN);
		 ReadFile(RomHandle,space,1,&dwRead,NULL);
		 if(BS)
		 {
			 _swab( space, space, sizeof( 2) );
		 }
		 something=space[0];
	 return (_int8)something;
	 }
	 else
	 {
		 SetFilePointer(RomHandle,vaddr-OldPC,0,FILE_BEGIN);
		 ReadFile(RomHandle,space,1,&dwRead,NULL);
		 if(BS)
		 {
			 _swab( space, space, sizeof( 2) );
		 }
		 something=space[0];
		 return (_int8)something;
	 }
	 break;
default:
	 sprintf(text,"Unhandled memory address: %x\n Stopped on opcode number: %d",(oldvaddr),CP0.r[9]);
	 MessageBox(hWnd,text, "Memory Error",MB_OK);
	 CPUisRunning=0;
	 return 0;
	 break;
 }
 vaddr=oldvaddr;
}
