/* Include Files */
#include <windows.h>
#include "ultra64.h"
#include <stdio.h>
#include "memory.h"
#include "trans.h"
HWND hMainWin;
HWND hList=NULL;
HANDLE CPUThread;
#include "CPUThread.h"

DWORD dwChildId;
//DWORD WINAPI CPUEmu(LPDWORD lpData);

HINSTANCE hInst; // Current Instance

LPCTSTR lpszAppName = "Ultra64";
LPCTSTR lpszTitle = "Ultra 64"; // Text for the Title bar

int APIENTRY WinMain(HINSTANCE hInstance,
					 HINSTANCE hPrevInstance,
					 LPSTR lpCmdLine,
					 int nCmdShow)
{
	
	HWND hWnd;
	MSG msg;
	WNDCLASSEX wc;

	// Setup Main window styles
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = (WNDPROC)WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(hInstance, lpszAppName);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName = lpszAppName;
	wc.lpszClassName = lpszAppName;
	wc.cbSize = sizeof(WNDCLASSEX);
	wc.hIconSm = LoadImage(hInstance,
						   lpszAppName,
						   IMAGE_ICON, 16, 16,
						   LR_DEFAULTCOLOR);

	// Register wc
	if(!RegisterClassEx(&wc)) return (FALSE);

	hInst=hInstance;

	// Create Main Window
	hWnd=CreateWindow(lpszAppName,
					  lpszTitle,
					  WS_OVERLAPPEDWINDOW,
					  CW_USEDEFAULT, 0,
					  CW_USEDEFAULT, 0,
					  NULL,
					  NULL,
					  hInstance,
					  NULL);
	hMainWin=hWnd;
	if(!hWnd) return (FALSE);

	// Display Main Window
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	hMenu=GetMenu(hWnd);
	CheckMenuItem(hMenu,
				  IDM_STOP,
				  MF_BYCOMMAND | MFS_CHECKED);
	while( GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return (msg.wParam);
}

LRESULT CALLBACK WndProc(HWND hWnd, 
						 UINT uMsg, 
						 WPARAM wParam, 
						 LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDM_OPEN:
		CloseHandle(RomHandle);
			for(zzz=0;zzz<31;zzz++)
			{
				CPU.r[zzz]=0;
				CP0.r[zzz]=0;
				CP1.r[zzz]=0;
				CP2.r[zzz]=0;
			}
			PC=0;
			CPUisRunning=1;
			OPENFILENAME OpenFileName;
			char szFileName[MAX_PATH];
			char szDirectory[255];

			memset(szFileName,0,sizeof(szFileName));
			memset (&OpenFileName, 0, sizeof(OpenFileName));

			OpenFileName.lStructSize  = sizeof(OpenFileName);
			OpenFileName.hwndOwner    = hWnd;
			OpenFileName.lpstrFilter  = "N64 roms (*.v64,*.bin,*.n64\0*.v64; *.bin; *.n64\0All files (*.*)\0*.*\0";
			OpenFileName.lpstrFile    = szFileName;
			OpenFileName.lpstrInitialDir    = szDirectory;
			OpenFileName.nMaxFile     = MAX_PATH;
			OpenFileName.Flags        = OFN_FILEMUSTEXIST|OFN_HIDEREADONLY;
			if (GetOpenFileName (&OpenFileName)) {				
				InvalidateRect(hWnd,NULL,TRUE);						
			}
			strcpy(title, "Ultra 64");
			if(szFileName[0]) strcat(title, " - ");
			strcat(title, szFileName);
			SetWindowText(hWnd, title);

			RomHandle=CreateFile(szFileName, GENERIC_READ,
				0, NULL, OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
			SetFilePointer(RomHandle,0,0,FILE_BEGIN);
			ReadFile(RomHandle,space,2,&dwRead, NULL);
			Byte_Swap=(space[0] << 8) + space[1];
			if(Byte_Swap != 0x8037)
			{
			if(Byte_Swap != 0x3680)
			{
				MessageBox(hWnd,"Not a valid ROM.","ROM",MB_OK);
				CloseHandle(RomHandle);
				SetWindowText(hWnd, lpszTitle);
				return(FALSE);
				break;
			}
			}
	if(Byte_Swap== 0x8037) 
	{
		BS=0;
		//MessageBox(hWnd,"Not byteswapped","ROM",MB_OK);
	}
	else
	{
		BS=1;
		MessageBox(hWnd,"Byteswapped\n(Can't run byteswapped ROMs)","ROM",MB_OK);
		CloseHandle(RomHandle);
		SetWindowText(hWnd, lpszTitle);
		return(FALSE);
	}
		
	SetFilePointer(RomHandle,8,0,FILE_BEGIN);
	ReadFile(RomHandle,space,4,&dwRead,NULL);
	if(BS==1)
	{
		_swab( space, space, sizeof( 4) );
	}
	PC=(space[0] << 24) + (space[1] << 16) + (space[2] << 8) + space[3];
	OldPC=PC;
	SetFilePointer(RomHandle,32,0,FILE_BEGIN);
	ReadFile(RomHandle,ROMName,20,&dwRead,NULL);
	if(BS==1)
	{
		_swab( ROMName, ROMName, sizeof( ROMName ) );
	}
		
	SetFilePointer(RomHandle,59,0,FILE_BEGIN);
	ReadFile(RomHandle,space,1,&dwRead,NULL);
	ManufacturerCode = space[0];
	switch(ManufacturerCode)
	{
	case 78:
		strcpy(Manufacturer, "Nintendo");
		break;
	default:
		strcpy(Manufacturer, " ");
		break;
	}

	hMenu = GetMenu(hWnd);
	EnableMenuItem(hMenu, 
				   IDM_START, 
				   MFS_ENABLED | MF_BYCOMMAND);
	EnableMenuItem(hMenu, 
				   IDM_PAUSE, 
				   MFS_ENABLED | MF_BYCOMMAND);
	EnableMenuItem(hMenu, 
				   IDM_RESET, 
				   MFS_ENABLED | MF_BYCOMMAND);
	//EnableMenuItem(hMenu, 
	//			   IDM_ENTER, 
	//			   MFS_ENABLED | MF_BYCOMMAND);

	//Copy 1000 bytes to RDRAM
	_int8 blahh;
	for(zzz=1;zzz<4096;zzz=zzz+1)
	{
	SetFilePointer(RomHandle,zzz,0,FILE_BEGIN);
	ReadFile(RomHandle,space,1,&dwRead,NULL);
	blahh=space[0];
	WriteMemory(PC+zzz-64,blahh, hWnd);
	}	
	break;

		case IDM_ENTER:
			break;
			
		case IDM_CLOSE:
			break;

		case IDM_STOP:
			uState=GetMenuState(hMenu,
									 IDM_STOP,
									 MF_BYCOMMAND);
			if(uState & MFS_CHECKED)
			{
				CheckMenuItem(hMenu, 
							  IDM_STOP,
							  MF_BYCOMMAND | MFS_UNCHECKED);
				STOP_OP=FALSE;
			}
			else
			{
				CheckMenuItem(hMenu, 
							  IDM_STOP,
							  MF_BYCOMMAND | MFS_CHECKED);
				STOP_OP=TRUE;
			}
			break;
		case IDM_ROM:
			CreateDialog(hInst, 
				         "ROM", 
					     hWnd, 
					     (DLGPROC)ROM);
			break;
		case IDM_SHOW:
			uState=GetMenuState(hMenu,
									 IDM_SHOW,
									 MF_BYCOMMAND);
			if(uState & MFS_CHECKED)
			{
				CheckMenuItem(hMenu, 
							  IDM_SHOW,
							  MF_BYCOMMAND | MFS_UNCHECKED);
				SHOW=FALSE;
			}
			else
			{
				CheckMenuItem(hMenu, 
							  IDM_SHOW,
							  MF_BYCOMMAND | MFS_CHECKED);
				SHOW=TRUE;
			}
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;

		case IDM_START:
			CPUisRunning=1;
			CPUThread=CreateThread(NULL,
							  0,
							  (LPTHREAD_START_ROUTINE)CPUEmu,
							  hList,
							  0,
							  &dwChildId);
			break;
		case IDM_PAUSE:
			CPUisRunning=0;
			break;
		case IDM_RESET:
			for(zzz=0;zzz<31;zzz++)
			{
				CPU.r[zzz]=0;
				CP0.r[zzz]=0;
				CP1.r[zzz]=0;
				CP2.r[zzz]=0;
			}
			PC=OldPC;
			break;
		case IDM_ABOUT:
			CreateDialog(hInst, 
				         "About", 
					     hWnd, 
					     (DLGPROC)About);
			break;
		}
		break;
	
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	
	default:
		return(DefWindowProc(hWnd, 
							 uMsg, 
							 wParam, 
							 lParam));
	}
	return (0L);
}

LRESULT CALLBACK About(HWND hDlg,
					   UINT uMsg,
					   WPARAM wParam,
					   LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_INITDIALOG:
		break;
	
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDCANCEL:
			EndDialog(hDlg, IDCANCEL);
			break;
		}
		break;

	default:
		return(FALSE);
	}
	return(TRUE);
}

LRESULT CALLBACK ROM(HWND hDlg,
					   UINT uMsg,
					   WPARAM wParam,
					   LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_INITDIALOG:
		ROMNameHandle=GetDlgItem(hDlg,IDC_ROMNAME);
		SendMessage(ROMNameHandle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)ROMName);
		ManufacturerHandle=GetDlgItem(hDlg,IDC_MANUFACTURER);
		SendMessage(ManufacturerHandle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)Manufacturer);
		
		break;
	
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDCANCEL:
			EndDialog(hDlg, IDCANCEL);
			break;
		}
		break;

	default:
		return(FALSE);
	}
	return(TRUE);
}

