int Translate(_int32 opa, HWND hWnd)
{
	Ops.op=opa >> 26;
	Ops.rs=(opa << 6) >> 27;
	Ops.rt=(opa << 11) >> 27;
	Ops.immediate=(opa << 16) >> 16;
	Ops.target=(opa << 6) >> 6;
	Ops.rd=(opa << 16) >> 27;
	Ops.sa=(opa << 21) >> 28;
	Ops.funct=(opa << 26) >> 26;
	Ops.code=(opa << 6) << 12;
	Ops.codea=(opa << 16)  >> 22;
	Ops.codeb=(opa << 21) >> 21;
	
 switch (Ops.op)
 {
 case 32:
	 strcpy(OC,"LB - Load Byte");
     CPU.r[Ops.rt]=(signed _int8)ReadMemory(Ops.rs+Ops.immediate,hWnd);    
	 PC=PC+4;
     break;
 case 36:
	 strcpy(OC,"LBU - Load Byte Unsigned");
     CPU.r[Ops.rt]=(unsigned _int8)ReadMemory(Ops.rs+Ops.immediate,hWnd);
	 PC=PC+4;
     break;
 case 55:
	 strcpy(OC,"LD - Load Doubleword");
	 space[0]=(_int8)ReadMemory(Ops.rs+Ops.immediate,hWnd);
	 space[1]=(_int8)ReadMemory(Ops.rs+Ops.immediate+1,hWnd);
	 space[2]=(_int8)ReadMemory(Ops.rs+Ops.immediate+2,hWnd);
	 space[3]=(_int8)ReadMemory(Ops.rs+Ops.immediate+3,hWnd);
	 CPU.r[Ops.rt]=(space[0] << 24) + (space[1] << 16) + (space[2] << 8) + space[3];
	 PC=PC+4;
     break;
 case 26:
	 strcpy(OC,"LDL - Load Doubleword Left");
	 PC=PC+4;
     return -1;
	 break;
 case 27:
	 strcpy(OC,"LDR - Load Doubleword Right");
	 PC=PC+4;
     return -1;
	 break;
 case 33:
	 strcpy(OC,"LH");
	 CPU.r[Ops.rt]=(signed _int8)ReadMemory(Ops.rs+Ops.immediate,hWnd);
	 PC=PC+4;
     break;
 case 37:
	 strcpy(OC,"LHU");
	 CPU.r[Ops.rt]=(unsigned _int8)ReadMemory(Ops.rs+Ops.immediate,hWnd);
	 PC=PC+4;
	 break;
 case 48:
	 strcpy(OC,"LL");
	 PC=PC+4;
	 return -1;
	 break;
 case 52:
	 strcpy(OC,"LLD");
	 PC=PC+4;
	 return -1;
	 break;
 case 35:
	 strcpy(OC,"LW - Load Word");
	 CPU.r[Ops.rt]=((ReadMemory(Ops.immediate+Ops.rs, hWnd)) <<8)+(ReadMemory(Ops.immediate+Ops.rs, hWnd));	 
	 PC=PC+4;
     break;
 case 34:
	 strcpy(OC,"LWL");
	 PC=PC+4;
         return -1;
	 break;
 case 38:
	 strcpy(OC,"LWR");
	 PC=PC+4;
         return -1;
	 break;
 case 39:
	 strcpy(OC,"LWU");
	 PC=PC+4;
         return -1;
	 break;
 case 40:
	 strcpy(OC,"SB");
	 PC=PC+4;
         return -1;
	 break;
 case 56:
	 strcpy(OC,"SC");
	 PC=PC+4;
	 return -1;
	 break;
 case 60:
	 strcpy(OC,"SCD");
	 PC=PC+4;
	 return -1;
	 break;
 case 63:
	 strcpy(OC,"SD");
	 PC=PC+4;
         return -1;
	 break;
 case 44:
	 strcpy(OC,"SDL");
	 PC=PC+4;
	 return -1;
	 break;
 case 45:
	 strcpy(OC,"SDR");
	 PC=PC+4;
	 return -1;
	 break;
 case 41:
	 strcpy(OC,"SH");
	 PC=PC+4;
	 return -1;
	 break;
 case 43:
	 strcpy(OC,"SW - Store Word");
	 space[0]=((_int8)CPU.r[Ops.rt] >> 8);
	 space[1]=((_int8)(CPU.r[Ops.rt] << 8) >> 8);
	 WriteMemory((Ops.immediate+Ops.rs),(space[0]),hWnd);
	 WriteMemory((Ops.immediate+Ops.rs+1),(space[1]),hWnd);
	 PC=PC+4;
     break;
 case 42:
	 strcpy(OC,"SWL");
	 PC=PC+4;
	 return -1;
	 break;
 case 46:
	 strcpy(OC,"SWR");
	 PC=PC+4;
	 return -1;
	 break;
 case 8:
	 strcpy(OC,"ADDI");
	 CPU.r[Ops.rt]=CPU.r[Ops.rs] + (signed _int16)Ops.immediate;
	 PC=PC+4;
	 break;
 case 9:
	 strcpy(OC,"ADDIU");
	 CPU.r[Ops.rt]=(CPU.r[Ops.rs] + (unsigned _int16)Ops.immediate);
	 PC=PC+4;
	 break;
 case 12:
	strcpy(OC,"ANDI");
        CPU.r[Ops.rd] = CPU.r[Ops.rs] & Ops.immediate;
	PC=PC+4;
	break;
 case 24:
	 strcpy(OC,"DADDI");
	 CPU.r[Ops.rt] = CPU.r[Ops.rs] + Ops.immediate;
	 PC=PC+4;
	 break;
 case 25:
	 strcpy(OC,"DADDIU");
	 CPU.r[Ops.rt] = CPU.r[Ops.rs] + Ops.immediate;
	 PC=PC+4;
	 break;
 case 15:
	 strcpy(OC,"LUI");
	 CPU.r[Ops.rt]=Ops.immediate << 16;
	 PC=PC+4;
	 break;
 case 13:
	 strcpy(OC,"ORI");
         CPU.r[Ops.rt]=CPU.r[Ops.rs] | Ops.immediate;
	 PC=PC+4;
	 break;
 case 10:
	 strcpy(OC,"SLTI");
	 if(CPU.r[Ops.rs] < Ops.immediate)
	 {
		 CPU.r[Ops.rd]=1;
	 }
	 else
	 {
		 CPU.r[Ops.rd]=0;
	 }
	 PC=PC+4;
	 break;
 case 11:
	 strcpy(OC,"SLTIU");
	 if(CPU.r[Ops.rs] < Ops.immediate)
	 {
		 CPU.r[Ops.rd]=1;
	 }
	 else
	 {
		 CPU.r[Ops.rd]=0;
	 }
	 PC=PC+4;
	 break;
 case 14:
	 strcpy(OC,"XORI");
	 PC=PC+4;
	 return -1;
	 break;
 case 4:
	 strcpy(OC,"BEQ");
	 if(CPU.r[Ops.rs] == CPU.r[Ops.rt])
	 {
		DelayPC=PC+4;
		PC=DelayPC+((_int16)(Ops.immediate-1) << 2);
	 }
	 PC=PC+4;
	 break;
 case 20:
	 strcpy(OC,"BEQL");
	 PC=PC+4;
	 return -1;
	 break;
 case 7:
	 strcpy(OC,"BGTZ");
	 PC=PC+4;
	 return -1;
	 break;
 case 23:
	 strcpy(OC,"BGTZL");
	 PC=PC+4;
	 return -1;
	 break;
 case 6:
	 strcpy(OC,"BLEZ");
	 PC=PC+4;
	 return -1;
	 break;
 case 22:
	 strcpy(OC,"BLEZL");
	 PC=PC+4;
	 return -1;
	 break;
 case 5:
	 strcpy(OC,"BNE");
	 if(CPU.r[Ops.rt] != CPU.r[Ops.rs])
	 {
		 DelayPC=PC+4;
		 PC=PC+((_int16)(Ops.immediate-1) << 2);
	 }
	 PC=PC+4;
	 break;
 case 21:
	 strcpy(OC,"BNEL");
	 PC=PC+4;
	 return -1;
	 break;
 case 2:
	 strcpy(OC,"J");
	 PC=PC+4;
	 return -1;
	 break;
 case 3:
	 strcpy(OC,"JAL");
	 CPU.r[31]=PC+8;
	 PC=PC+4;
	 break;
 case 47:
	 strcpy(OC,"CACHE");
	 PC=PC+4;
	 break;
 case 53:
	 strcpy(OC,"LDC1");
	 PC=PC+4;
	 return -1;
	 break;
 case 49:
	 strcpy(OC,"LWC1");
	 PC=PC+4;
	 return -1;
	 break;
 case 61:
	 strcpy(OC,"SDC1");
	 PC=PC+4;
	 return -1;
	 break;
 case 57:
	 strcpy(OC,"SWC1");
	 PC=PC+4;
	 return -1;
	 break;
 case 54:
	 strcpy(OC,"LDC2");
	 PC=PC+4;
	 return -1;
	 break;
 case 50:
     strcpy(OC,"LWC2");
     PC=PC+4;
     return -1;
     break;
 case 62:
	 strcpy(OC,"SDC2");
	 PC=PC+4;
	 return -1;
	 break;
 case 58:
	 strcpy(OC,"SWC2");
	 PC=PC+4;
	 return -1;
	 break;
 case 0:
	 switch (Ops.funct)
	 {
	 case 15:
		 strcpy(OC,"SYNC");
		 PC=PC+4;
		 break;
	 case 32:
		strcpy(OC,"ADD");
		CPU.r[Ops.rd] = CPU.r[Ops.rs] + CPU.r[Ops.rt];
		PC=PC+4; 
		break;
	 case 33:
		strcpy(OC,"ADDU");
		CPU.r[Ops.rd] = CPU.r[Ops.rs] + CPU.r[Ops.rt];
		PC=PC+4;
		break;
	 case 36:
		strcpy(OC,"AND");
                CPU.r[Ops.rd] = CPU.r[Ops.rs] & CPU.r[Ops.rt];
		PC=PC+4;
		break;
	 case 44:
		 strcpy(OC,"DADD");
		 CPU.r[Ops.rd] = CPU.r[Ops.rs] + CPU.r[Ops.rt];
		 PC=PC+4;
		 break;
	 case 45:
		 strcpy(OC,"DADDU");
		 CPU.r[Ops.rd] = CPU.r[Ops.rs] + CPU.r[Ops.rt];
		 PC=PC+4;
		 break;
	 case 30:
		strcpy(OC,"DDIV");
		PC=PC+4;
		return -1;
		break;
	 case 31:
		 strcpy(OC,"DDIVU");
		 PC=PC+4;
		 return -1;
		 break;
	 case 26:
		 strcpy(OC,"DIV");
		 PC=PC+4;
		 return -1;
		 break;
	 case 27:
		 strcpy(OC,"DDIVU");
		 PC=PC+4;
		 return -1;
		 break;
	 case 56:
		 strcpy(OC,"DSLL");
		 PC=PC+4;
		 return -1;
		 break;
	 case 60:
		 strcpy(OC,"DSLL32");
		 PC=PC+4;
		 return -1;
		 break;
	 case 20:
		 strcpy(OC,"DSLLV");
		 PC=PC+4;
		 return -1;
		 break;
	 case 59:
		 strcpy(OC,"DSRA");
		 PC=PC+4;
		 return -1;
		 break;
	 case 63:
		 strcpy(OC,"DSRA32");
		 PC=PC+4;
		 return -1;
		 break;
	 case 23:
		 strcpy(OC,"DSRAV");
		 PC=PC+4;
		 return -1;
		 break;
	 case 58:
		 strcpy(OC,"DSRL");
		 PC=PC+4;
		 return -1;
		 break;
	 case 62:
		 strcpy(OC,"DSRL32");
		 PC=PC+4;
		 return -1;
		 break;
	 case 22:
		 strcpy(OC,"DSRLV");
		 PC=PC+4;
		 return -1;
		 break;
	 case 46:
		 strcpy(OC,"DSUB");
		 CPU.r[Ops.rd] = CPU.r[Ops.rs] - CPU.r[Ops.rt];
		 PC=PC+4;
		 break;
	 case 47:
		 strcpy(OC,"DSUBU");
		 CPU.r[Ops.rd] = CPU.r[Ops.rs] - CPU.r[Ops.rt];
		 PC=PC+4;
		 break;
	 case 16:
		 strcpy(OC,"MFHI");
		 CPU.r[Ops.rd]=HI;
		 PC=PC+4;
		 break;
	 case 18:
		 strcpy(OC,"MFLO");
		 CPU.r[Ops.rd]=LO;
		 PC=PC+4;
		 break;
	 case 17:
		 strcpy(OC,"MTHI");
		 HI=CPU.r[Ops.rs];
		 PC=PC+4;
		 break;
	 case 19:
		 strcpy(OC,"MTLO");
		 LO=CPU.r[Ops.rs];
		 PC=PC+4;
		 break;
	 case 24:
		 strcpy(OC,"MULT");
		 PC=PC+4;
		 return -1;
		 break;
	 case 25:
		 strcpy(OC,"MULTU");
		 PC=PC+4;
		 return -1;
		 break;
	 case 39:
		 // Below is Adi's emulation of NOR
		 strcpy(OC,"NOR");
                 ((CPU.r[Ops.rd] != CPU.r[Ops.rs]) | (CPU.r[Ops.rd] != CPU.r[Ops.rt]));
		 PC=PC+4;
		 break;
	 case 37:
		 strcpy(OC,"OR");
                 CPU.r[Ops.rd]=(CPU.r[Ops.rs] | CPU.r[Ops.rt]);
		 PC=PC+4;
		 break;
	 case 0:
		 // SLL or NOP
		 if((Ops.rd==0) && (Ops.rt==0) && (Ops.sa==0))
		 {
			strcpy(OC,"NOP");
			PC=PC+4;
			break;
		 }
		 else
		 {
			strcpy(OC,"SLL");
			//nothings=(int)CPU.r[Ops.rt];
			CPU.r[Ops.rd]=CPU.r[Ops.rt] << Ops.sa;
		 }
		 PC=PC+4;
		 break;
	 case 4:
		 strcpy(OC,"SLLV");
		 PC=PC+4;
		 CPU.r[Ops.rd]=CPU.r[Ops.rt] << Ops.rs;
		 break;
	 case 42:
		 strcpy(OC,"SLT"); // - Emulated by SubIce
		 PC=PC+4;
		 if(CPU.r[Ops.rs] < CPU.r[Ops.rt])
		 {
			 CPU.r[Ops.rd]=1;
		 }
		 else
		 {
			 CPU.r[Ops.rd]=0;
		 }
		 break;
	 case 43:
		 strcpy(OC,"SLTU"); //- Emulated by SubIce
		 PC=PC+4;
		 if((unsigned)CPU.r[Ops.rs] < (unsigned)CPU.r[Ops.rt])
		 {
			 CPU.r[Ops.rd]=1;
		 }
		 else
		 {
			 CPU.r[Ops.rd]=0;
		 }
		 
		 break;
	 case 3:
		 strcpy(OC,"SRA");
		 PC=PC+4;
		 return -1;
		 break;
	 case 7:
		 strcpy(OC,"SRAV");
		 PC=PC+4;
		 CPU.r[Ops.rd]=CPU.r[Ops.rt] >> (int)CPU.r[Ops.rs];
		 break;
	 case 2:
		 strcpy(OC,"SRL");
		 PC=PC+4;
		 return -1;
		 break;
	 case 6:
		 strcpy(OC,"SRLV");
		 PC=PC+4;
		 return -1;
		 break;
	 case 34:
		 strcpy(OC,"SUB");
		 PC=PC+4;
		 return -1;
		 break;
	 case 35:
		 strcpy(OC,"SUBU");
		 PC=PC+4;
		 return -1;
		 break;
	 case 38:
		 strcpy(OC,"XOR");
		 PC=PC+4;
		 return -1;
		 break;
	 case 9:
		 strcpy(OC,"JALR");
		 PC=PC+4;
		 return -1;
		 break;
	 case 8:
		 strcpy(OC,"JR");
                 PC=(_int32)CPU.r[Ops.rs];
		 break;
	 case 13:
		 strcpy(OC,"BREAK");
		 PC=PC+4;
		 return -1;
		 break;
	 case 12:
		 strcpy(OC,"SYSCALL");
		 PC=PC+4;
		 return -1;
		 break;
	 case 52:
		 strcpy(OC,"TEQ");
		 PC=PC+4;
		 return -1;
		 break;
	 case 48:
		 strcpy(OC,"TGE");
		 PC=PC+4;
		 return -1;
		 break;
	 case 49:
		 strcpy(OC,"TGEU");
		 PC=PC+4;
		 return -1;
		 break;
	 case 50:
		 strcpy(OC,"TLT");
		 PC=PC+4;
		 return -1;
		 break;
	 case 51:
		 strcpy(OC,"TLTU");
		 PC=PC+4;
		 return -1;
		 break;
	 case 54:
		 strcpy(OC,"TNE");
		 PC=PC+4;
		 return -1;
		 break;
	 }
	 break;
 case 16:
	 if(Ops.codeb==0){
		 switch (Ops.rs)
	{
	 case 2:
		 strcpy(OC,"CFC0");
		 CPU.r[Ops.rt]=CPU.r[Ops.rd];
		 PC=PC+4;
		 break;
	 case 6:
		 strcpy(OC,"CTC0");
		 CPU.r[Ops.rd]=CPU.r[Ops.rt];
		 PC=PC+4;
		 break;
	 case 1:
		 strcpy(OC,"DMFC0");
		 PC=PC+4;
		 return -1;
		 break;
	 case 5:
		 strcpy(OC,"DMTC0");
		 PC=PC+4;
		 return -1;
		 break;
	 case 0:
		 strcpy(OC,"MFC0");
		 PC=PC+4;
		 return -1;
		 break;
	 case 4:
		 strcpy(OC,"MTC0");
		 CP0.r[Ops.rd]=CPU.r[Ops.rt];
		 PC=PC+4;
		 break;
	}
	 }
	else
	{	
		switch(Ops.codeb)
		{
		 case 24:
			strcpy(OC,"ERET");
			PC=PC+4;
			return -1;
			break;
	 case 8:
		 strcpy(OC,"TLBP");
		 PC=PC+4;
		 return -1;
		 break;
	 case 1:
		 strcpy(OC,"TLBR");
		 PC=PC+4;
		 return -1;
		 break;
	 case 2:
		 strcpy(OC,"TLBWI");
		 PC=PC+4;
		 return -1;
		 break;
	 case 6:
		 strcpy(OC,"TLBWR");
		 PC=PC+4;
		 return -1;
		 break;
		}
	}
		break;
 default:
	 sprintf(text,"Unknown opcode: %x\n Emulation stopped at instruction number %d",(Ops.op),CP0.r[9]);
	 MessageBox(hWnd,text, "Unknown Opcode",MB_OK);
	 if(STOP_OP)
	 {
	 CPUisRunning=0;
	 return -1;
	 }
	 break;
 }
 return 0;
}
